"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * react app preset
 * @author: sunkeysun
 */
const lodash_merge_1 = __importDefault(require("lodash.merge"));
exports.default = (api, opts = {}, env = 'production') => {
    const isProduction = env === 'production';
    const { alias } = opts;
    function ifRequire(pkg, options = {}) {
        if (pkg && opts[pkg] !== false) {
            return [require(pkg), (0, lodash_merge_1.default)(options, opts?.[pkg] ?? {})];
        }
        return false;
    }
    api.cache.using(() => env);
    return {
        presets: [
            ifRequire('@babel/preset-env'),
            ifRequire('@babel/preset-react', { runtime: 'automatic' }),
        ],
        plugins: [
            ifRequire('@babel/plugin-proposal-decorators', { legacy: true }),
            ifRequire('@babel/plugin-proposal-export-default-from'),
            ifRequire('@babel/plugin-proposal-export-namespace-from'),
            ifRequire('@babel/plugin-transform-runtime', { regenerator: true }),
            ifRequire(isProduction && 'react-refresh/babel'),
            alias && [require('babel-plugin-module-resolver'), { alias }],
        ].filter(Boolean),
    };
};
